<?php 

include("../includes/config.php");
include("../../quiklrn_app/rester_api.php");
include("../../quiklrn_app/config.php");
// include("../includes/s3.php");
include("../includes/presignedUrl.php");

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);


$method="Unknown";
if(isset($_REQUEST["method"]))
	$method=$_REQUEST["method"];

$path="";
if(isset($_REQUEST["path"]))
	$path=$_REQUEST["path"];
	
if($method==="upload"){
	$AWS_DESTINATION_PATH = S3_BASE_URI."/".STATIC_CONTAINER."/xyz.png";
	$path= $AWS_DESTINATION_PATH;
	$src_path = $_REQUEST["src"];
	
	if(empty($path) || empty($_REQUEST['src'])) {
		return header('HTTP/1.1 400 Bad Request', true, 400);
	}
	
	$accepted_files = ["jpg", "jpeg", "png", "gif", "webp", "tiff", "psd", "raw", "bmp", "heif", "indd", "svg", "eps"];
	$file_ext = strtolower(pathinfo($path, PATHINFO_EXTENSION));
	
	if(empty($path) || !in_array($file_ext, $accepted_files)) {
		return header('HTTP/1.1 400 Bad Request', true, 400);
	}
	
	$src_path = $_REQUEST['src'];
	// $dst_path = $path;
	$dst_path = $AWS_DESTINATION_PATH;
	echo s3_cloud_upload($src_path,$dst_path); //return the path
}else if($method==="delete"){
	echo s3_cloud_delete($path); //return true or false
}else if($method == 'uploadFile'){
	echo s4_cloud_upload(); //return the path	
}else if($method == 'sendEmailWorkFlow'){
	sendEmailWorkFlow();
}else if($method == 'generatePresignedURL'){
	generatePresignedURL();
}

function array_to_csv_download() {

    ini_set('display_errors', 1);
    ini_set('display_startup_errors', 1);
    error_reporting(E_ALL);

    $delimiter = ",";
    $filename = "reports_" . date('Y-m-d') . ".csv";
   
    $tmpDir = '../../../tmp/output.csv';
    
    // $csvFile = fopen('/var/www/html/tmp/xyz.csv', 'w');
    $csvFile = fopen($tmpDir, 'w');
   
    if (!flock($csvFile, LOCK_EX)) {
        error_log('Cannot get lock!');
        return false;
    } 

    $fields = array('Dept Name', 'Course Name', 'Course Code');
    fputcsv($csvFile, $fields, $delimiter);
    $array = array(['department_name'=> 'Gen', 'course_name'=> 'Maths', 'course_code' => '123']);
    $csvData = array();
    foreach($array as $data){
        $csvData =  array($data['department_name'],$data['course_name'], $data['course_code']); 
        fputcsv($csvFile, $csvData);
    }
    fclose($csvFile);
    return true;
}   

function sendEmailWorkFlow()
{
	$email_type = isset($_REQUEST['email_type']) ? $_REQUEST['email_type']  : 0;
	if($email_type == 0){
	    return get_generic_response(404, null, "Email Type not found!");
	}
	$fromUserId = isset($_REQUEST['fromUserId']) && ($_REQUEST['fromUserId']) ? ($_REQUEST['fromUserId']) : 0;
	if ($fromUserId == 0) {
		return get_generic_response(404, null, "fromUserId not found!");
	}
	if($email_type == 2){
		$csvDownload = array_to_csv_download();
		if($csvDownload){
			// $uploadFile = (s4_cloud_upload($fromUserId));
			$uploadFile = (generateUploadedPresignedURL($fromUserId));
			
			$statusCode = $uploadFile['status_code'];	
			$action_url = $uploadFile['objectURI'];
			if($statusCode == 200){
				$get = $_GET;
				echo $uploadFile['msg']."</br>";
				
				echo $action_url."</br>";
				save_email($get, $action_url);
			}
		}
	}elseif($email_type == 1){
		$get = $_GET;
		save_email($get);
	}
    
}

function generatePresignedURL(){
	$fromUserId = isset($_REQUEST['fromUserId']) && ($_REQUEST['fromUserId']) ? ($_REQUEST['fromUserId']) : 0;
	if ($fromUserId == 0) {
		return get_generic_response(404, null, "fromUserId not found!");
	}
	$uploadFile = (generateUploadedPresignedURL($fromUserId));
}

function save_email($get, $action_url='') {
	
	 	$notification_type="3";
		$fromEmail = isset($get['fromEmail']) && ($get['fromEmail']) ? ($get['fromEmail']) : 0;
	
		if ($fromEmail == 0) {
			return get_generic_response(404, null, "fromEmail not found!");
		}
		$fromName = isset($get['fromName']) && ($get['fromName']) ? ($get['fromName']) : 0;
		if ($fromName == 0) {
			return get_generic_response(404, null, "fromName not found!");
		}
		$fromUserId = isset($get['fromUserId']) && ($get['fromUserId']) ? ($get['fromUserId']) : 0;
		if ($fromUserId == 0) {
			return get_generic_response(404, null, "fromUserId not found!");
		}
		$toEmail = isset($get['toEmail']) && count($get['toEmail']) ? $get['toEmail'] : 0;
		if ($toEmail == 0) {
			return get_generic_response(404, null, "toEmail not found!");
		}
		$toName = isset($get['toName']) && count($get['toName']) ? $get['toName'] : 0;
		if ($toName == 0) {
			return get_generic_response(404, null, "toName not found!");
		}

		$toUserId = isset($get['toUserId']) && count($get['toUserId']) ? $get['toUserId'] : 0;
		if ($toUserId == 0) {
			return get_generic_response(404, null, "toUserId not found!");
		}
		
		$subject = isset($get['subject']) && ($get['subject']) ? $get['subject'] : 0;
		if ($subject == 0) {
			return get_generic_response(404, null, "subject not found!");
		}
		$message = isset($get['message']) && ($get['message']) ? $get['message'] : 0;
		if ($message == 0) {
			return get_generic_response(404, null, "message not found!");
		}

		$action_value = isset($get['action_value']) && ($get['action_value']) ? $get['action_value'] : '';
		
		// $action_url = isset($get['action_url']) && ($get['action_url']) ? $get['action_url'] : '';
  
		$notification_type = 1;
		$notifier_history_id = 1;

		$toEmailCount = count($toEmail);
		for($i = 0; $i<($toEmailCount); $i++)
		{
			// echo $i+1;
			$params = array(    'method' => 'sendEmail', 
				'fromEmail' => $fromEmail,
				'fromName' => $fromName, 
				'fromUserId' => $fromUserId,
				'toEmail' => $toEmail[$i], 
				'toName' => $toName[$i],
				'toUserId' => $toUserId[$i], 
				'subject' => $subject,
				'message' => $message, 
				'action_value' => $action_value,
				'action_url' => $action_url,
				'notification_type' => 1                        
			);
			$callAPI = json_decode( CallAPI( 'GET', QUIKLRN_API_URL, $params ), true );
			var_dump($callAPI);
		}

		die;

	echo "<pre>";
	var_dump($aa);die;
}
?>
