<?php
require_once(ROOT_DIRECTORY."/includes/external/aws/aws-autoloader.php");
use Aws\S3\S3Client;

function s3_get_cloud_service() {
	$s3Client = S3Client::factory(
		[
			'version' => 'latest',
			'region'  => 'ap-south-1',
			'credentials' => [
				'key'    => "AKIA4ROQEOUP4XZNNHHA",
				'secret' => "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"
			]
		 ]
	  );
	  return $s3Client;
}

function s3_cloud_upload($src_local,$dst_cloud) {
    $container = STATIC_CONTAINER;
    $dst_cloud = remove_slash($dst_cloud);
    $s3Client = s3_get_cloud_service();
    try {
		$s3Client->putObject([
			'Bucket'     => $container,
			'Key'        => $dst_cloud,
			'SourceFile' => $src_local,    // like /var/www/vhosts/mysite/file.csv
			'ACL'        => 'private',
		]);
	  
	  } catch (S3Exception $e) {
		echo $e->getMessage();
      }
      return S3_BASE_URI.$dst_cloud."?".time();
}

function s3_cloud_download($cloud_path,$local_path) {
    $container = STATIC_CONTAINER;
    $cloud_path = remove_slash($cloud_path);
    $s3Client = s3_get_cloud_service();
    $objectExists = $s3Client->doesObjectExist($container, $cloud_path);
    if($objectExists && $cloud_path != "") {
        $object = $s3Client->getObject(array(
            'Bucket' => $container,
            'Key'    => $cloud_path
        ));
        file_put_contents($local_path, $object['Body']);
        return $local_path;
    } else {
        return null;
    }
}

function s3_cloud_delete($src){
    $container = STATIC_CONTAINER;
    $s3Client = s3_get_cloud_service();
    $src = remove_slash($src);
    $objectExists = $s3Client->doesObjectExist($container, $src);
    if($objectExists&&$src!="") {
        $s3Client->deleteObject([
            'Bucket' => $container,
            'Key' => $src
        ]);
        return true;
    } else {
        return false;
    }
}

function remove_slash($string){    
	if(substr($string, 0, strlen('/')) === '/')
		return substr($string, 1);
	else
		return $string;
}
?>
